"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}var program=_interopDefault(require("commander")),chalk=_interopDefault(require("chalk")),path=_interopDefault(require("path")),execa=_interopDefault(require("execa")),Listr=_interopDefault(require("listr")),mkdirp=_interopDefault(require("mkdirp")),tar=_interopDefault(require("tar")),fs=_interopDefault(require("fs-extra")),flatMap=_interopDefault(require("lodash/flatMap")),globby=_interopDefault(require("globby")),kebabCase=_interopDefault(require("lodash/kebabCase")),inquirer=_interopDefault(require("inquirer"));const parseReplacementSpecTree=(e,a)=>Array.isArray(a)?{file:e,replacements:a}:flatMap(Object.entries(a),([a,t])=>parseReplacementSpecTree(path.join(e,a),t)),processFile=(e,a)=>async({file:t,replacements:r})=>{const o=await e(t,{encoding:"utf8",flag:"r"}),s=r.reduce((e,{regex:a,value:t})=>e.replace(a,t),o);return a(t,s,{encoding:"utf8",flag:"w"})},replaceInFiles=async(e,a,t=fs.readFile,r=fs.writeFile)=>Promise.all(parseReplacementSpecTree(e,a).map(processFile(t,r))),processTigerFile=async(e,a)=>{if(a){const a=e.replace(/--tiger(\..+)$/,"$1");await fs.remove(a),await fs.rename(e,a)}else await fs.remove(e)},processTigerFiles=async(e,a)=>{const t=path.posix.join(e,"./**/*--tiger.*"),r=await globby(t);return Promise.all(r.map(e=>processTigerFile(e,a)))},DEFAULT_SCHEMA="https",getSchema=e=>{const a=/^(\w+):\/\//i.exec(e);return a&&a[1]?a[1]:""},getHostnameWithSchema=e=>getSchema(e)?e:`https://${e}`,sanitizeAppName=kebabCase,verboseLog=e=>{console.log(`[VERBOSE]: ${e}`)},getTargetDirPath=(e,a)=>path.resolve(a||process.cwd(),e),copyAppFiles=async({targetDir:e})=>(mkdirp(e),tar.x({file:path.resolve(__dirname,"bootstrap.tgz"),strip:1,cwd:e})),performTemplateReplacements=({targetDir:e,sanitizedAppName:a,hostname:t,backend:r})=>{const o={"package.json":[{regex:/@gooddata\/gdc-app-name/,value:a},"tiger"===r?{regex:/@gooddata\/sdk-backend-bear/g,value:"@gooddata/sdk-backend-tiger"}:"","tiger"===r?{regex:/"refresh-ldm": "node .\/scripts\/refresh-ldm.js"/g,value:'"refresh-ldm": "node ./scripts/refresh-ldm.js --backend tiger"'}:"","https"!==(getSchema(t)||"https")?{regex:/"start": "cross-env HTTPS=true react-scripts start",/g,value:'"start": "react-scripts start",'}:""],src:{"constants.js":[{regex:/appName: "(.*?)"/,value:`appName: "${a}"`},{regex:/backend: "https:\/\/developer\.na\.gooddata\.com"/g,value:`backend: "${getHostnameWithSchema(t)}"`},"tiger"===r?{regex:/workspace: ""/g,value:'workspace: "workspace"'}:""],"setupProxy.js":["tiger"===r?{regex:/proxy\("\/gdc"/g,value:'proxy("/api"'}:""],components:{Header:{"Header.js":["tiger"===r?{regex:/import Aside from ".\/Aside";\n/g,value:""}:"","tiger"===r?{regex:/<Aside \/>/g,value:""}:""]}},contexts:{Auth:{"context.js":["tiger"===r?{regex:/@gooddata\/sdk-backend-bear/g,value:"@gooddata/sdk-backend-tiger"}:"","tiger"===r?{regex:/bearFactory/g,value:"tigerFactory"}:"","tiger"===r?{regex:/FixedLoginAndPasswordAuthProvider\([^)]+\)/g,value:"AnonymousAuthProvider()"}:"","tiger"===r?{regex:/FixedLoginAndPasswordAuthProvider/g,value:"AnonymousAuthProvider"}:""]}}}};return replaceInFiles(e,o)},setupApp=async e=>(await performTemplateReplacements(e),processTigerFiles(e.targetDir,"tiger"===e.backend)),runYarnInstall=({targetDir:e,install:a})=>a?execa("yarn",{cwd:e,stdio:[process.stdin,process.stdout,process.stderr]}).then(()=>!0).catch(()=>(console.log(chalk.red("Installation failed. Please make sure that you have yarn installed and try again.")),!1)):(console.log("Skipping installation because the --no-install flag was specified"),!0),outputFinalInstructions=({sanitizedAppName:e,install:a,targetDir:t})=>{console.log(`Success! Your GoodData-powered application "${e}" was created.`),console.log("You can start it using the following commands:"),console.log(chalk.cyan(`    cd ${path.relative(process.cwd(),t)}`)),a||console.log(chalk.cyan("    yarn install")),console.log(chalk.cyan("    yarn start"))},main=async e=>{const a={...e,targetDir:getTargetDirPath(e.sanitizedAppName,e.targetDir)};a.verbose&&verboseLog(`Target directory: ${a.targetDir}`);const t=new Listr([{title:"Copy app files",task:()=>copyAppFiles(a)},{title:"Set up app",task:()=>setupApp(a)}]);await t.run(),await runYarnInstall(a)&&outputFinalInstructions(a)},inquireName=()=>inquirer.prompt({message:"What is your application name?",name:"name",type:"input"}).then(e=>e.name),inquireHostname=e=>inquirer.prompt([{message:"What is your hostname?",name:"hostname",type:"list",choices:[{value:"https://secure.gooddata.com"},{value:"https://developer.na.gooddata.com"},{value:"https://salesengineering.na.gooddata.com"},{name:"I have a custom hostname",value:"WHITE_LABELLED"}],when:()=>e},{message:"Insert your hostname",name:"hostname",type:"input",when:({hostname:a})=>"WHITE_LABELLED"===a||!e}]).then(e=>e.hostname),getSanitizedAppName=async e=>{const a=e||await inquireName();if(!a)throw new Error("You must provide a name for your app");return sanitizeAppName(a)},getBootstrapData=async(e,{hostname:a,backend:t})=>{return{sanitizedAppName:await getSanitizedAppName(e),hostname:a||await inquireHostname(!t||"bear"===t)}},parseConfig=({hostname:e,appName:a},t)=>{if(!e)throw new Error("You must provide a hostname for your app");const r=sanitizeAppName(a||t);if(!r)throw new Error("You must provide a name for your app");return{sanitizedAppName:r,hostname:e}},getBootstrapData$1=async(e,{config:a})=>{let t={};try{t=await fs.readJSON(a,{encoding:"utf8",flag:"r"})}catch(e){throw new Error("The config file specified using the -c option was not found. Please check that the path you provided is correct.")}return parseConfig(t,e)};process.on("unhandledRejection",e=>console.error(e.message)),program.name("@gooddata/create-react-app").arguments("[app-name]").option("--hostname <hostname>","URL of your GoodData host").option("-c, --config <config>","path to configuration file").option("--target-dir <path>",'path to the directory to create the app in (default: ".")').option("--no-install","skip yarn installing the app dependencies").option("--verbose","output additional logs, useful mainly for debugging and bug reports").option("--backend <backend>","setting backend of the app (default: bear backend)").action(async e=>{const a=program.config?getBootstrapData$1:getBootstrapData,t=await a(e,program);return main({...t,install:program.install,targetDir:program.targetDir,verbose:program.verbose,backend:program.backend})}).parse(process.argv);
